<?php

function getDistance($apiKey, $latFrom, $lngFrom, $latTo, $lngTo) {
    $url = "https://maps.googleapis.com/maps/api/distancematrix/json?origins={$latFrom},{$lngFrom}&destinations={$latTo},{$lngTo}&key={$apiKey}";
    $response = file_get_contents($url);
    if ($response === FALSE) {
        die('Error occurred while fetching distance.');
    }
    return json_decode($response, true);
}

function getDirections($apiKey, $latFrom, $lngFrom, $latTo, $lngTo) {
    $url = "https://maps.googleapis.com/maps/api/directions/json?origin={$latFrom},{$lngFrom}&destination={$latTo},{$lngTo}&key={$apiKey}";
    
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $response = curl_exec($ch);
    curl_close($ch);

    if ($response === FALSE) {
        die('Error occurred while fetching directions.');
    }
    return json_decode($response, true);
}

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    $apiKey = 'AIzaSyC1LW5CzDguBt35OmfGe5qwXad9wFOdGSY'; // Replace with your Google Maps API key
    $latFrom = $_POST['latFrom'];
    $lngFrom = $_POST['lngFrom'];
    $latTo = $_POST['latTo'];
    $lngTo = $_POST['lngTo'];

    $distanceResult = getDistance($apiKey, $latFrom, $lngFrom, $latTo, $lngTo);
    $directionsResult = getDirections($apiKey, $latFrom, $lngFrom, $latTo, $lngTo);

    header('Content-Type: application/json');
    echo json_encode(['distance' => $distanceResult, 'directions' => $directionsResult]);
}
?>

<!DOCTYPE html>
<html>
<head>
    <title>Google Maps API with PHP</title>
</head>
<body>
    <h1>Calculate Distance and Get Directions</h1>
    <form method="POST" action="place_api.php">
        <label for="latFrom">Latitude From:</label>
        <input type="text" id="latFrom" name="latFrom" required>
        <label for="lngFrom">Longitude From:</label>
        <input type="text" id="lngFrom" name="lngFrom" required>
        <label for="latTo">Latitude To:</label>
        <input type="text" id="latTo" name="latTo" required>
        <label for="lngTo">Longitude To:</label>
        <input type="text" id="lngTo" name="lngTo" required>
        <button type="submit">Calculate</button>
    </form>
</body>
</html>
